"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoursesApi = exports.CoursesApiFactory = exports.CoursesApiFp = exports.CoursesApiAxiosParamCreator = void 0;
/* tslint:disable */
/* eslint-disable */
/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
var axios_1 = require("axios");
// Some imports not used depending on template conditions
// @ts-ignore
var base_1 = require("../base");
/**
 * CoursesApi - axios parameter creator
 * @export
 */
exports.CoursesApiAxiosParamCreator = function (configuration) {
    var _this = this;
    return {
        /**
         *
         * @summary Add a category
         * @param {CoursesCategoryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseAddCategory: function (body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    localVarPath = "/courses/category";
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Add a course description
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {CourseCodeDescriptionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseAddDescription: function (courseCode, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseAddDescription.');
                    }
                    localVarPath = "/course/{course_code}/description"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Add a course
         * @param {CourseBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseCreate: function (body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    localVarPath = "/course";
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Delete course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDelete: function (courseCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseDelete.');
                    }
                    localVarPath = "/course/{course_code}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Delete category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteCategory: function (categoryCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'categoryCode' is not null or undefined
                    if (categoryCode === null || categoryCode === undefined) {
                        throw new base_1.RequiredError('categoryCode', 'Required parameter categoryCode was null or undefined when calling courseDeleteCategory.');
                    }
                    localVarPath = "/courses/category/{category_code}"
                        .replace("{" + "category_code" + "}", encodeURIComponent(String(categoryCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGet: function (courseCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseGet.');
                    }
                    localVarPath = "/course/{course_code}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get backup of a course
         * @param {string} courseCode unique string identifier of the course to backup.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetBackup: function (courseCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseGetBackup.');
                    }
                    localVarPath = "/course/{course_code}/backup"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get list of categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetCategories: function (options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    localVarPath = "/courses/categories";
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetCategory: function (categoryCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'categoryCode' is not null or undefined
                    if (categoryCode === null || categoryCode === undefined) {
                        throw new base_1.RequiredError('categoryCode', 'Required parameter categoryCode was null or undefined when calling courseGetCategory.');
                    }
                    localVarPath = "/courses/category/{category_code}"
                        .replace("{" + "category_code" + "}", encodeURIComponent(String(categoryCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get list of courses
         * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
         * @param {number} [howmany] Number of results we want. Optional.
         * @param {number} [visibility] the visibility of the course, or all by default. Optional.
         * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
         * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetList: function (from, howmany, visibility, startwith, alsoSearchCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    localVarPath = "/courses";
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    if (from !== undefined) {
                        localVarQueryParameter['from'] = from;
                    }
                    if (howmany !== undefined) {
                        localVarQueryParameter['howmany'] = howmany;
                    }
                    if (visibility !== undefined) {
                        localVarQueryParameter['visibility'] = visibility;
                    }
                    if (startwith !== undefined) {
                        localVarQueryParameter['startwith'] = startwith;
                    }
                    if (alsoSearchCode !== undefined) {
                        localVarQueryParameter['alsoSearchCode'] = alsoSearchCode;
                    }
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get list of resources in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetResources: function (courseCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseGetResources.');
                    }
                    localVarPath = "/course/{course_code}/resources"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Adds a new term to the course glossary tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {ToolGlossaryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolAddGlossaryTerm: function (courseCode, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling toolAddGlossaryTerm.');
                    }
                    localVarPath = "/course/{course_code}/tool/glossary"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Adds an introduction text to specified tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {string} toolId The id of the tool.
         * @param {ToolIdIntroTextBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolAddIntroText: function (courseCode, toolId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling toolAddIntroText.');
                    }
                    // verify required parameter 'toolId' is not null or undefined
                    if (toolId === null || toolId === undefined) {
                        throw new base_1.RequiredError('toolId', 'Required parameter toolId was null or undefined when calling toolAddIntroText.');
                    }
                    localVarPath = "/course/{course_code}/tool/{tool_id}/intro_text"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "tool_id" + "}", encodeURIComponent(String(toolId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Deletes a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolDeleteGlossaryTerm: function (courseCode, glossaryId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling toolDeleteGlossaryTerm.');
                    }
                    // verify required parameter 'glossaryId' is not null or undefined
                    if (glossaryId === null || glossaryId === undefined) {
                        throw new base_1.RequiredError('glossaryId', 'Required parameter glossaryId was null or undefined when calling toolDeleteGlossaryTerm.');
                    }
                    localVarPath = "/course/{course_code}/tool/glossary/{glossary_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "glossary_id" + "}", encodeURIComponent(String(glossaryId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Edits a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {GlossaryGlossaryIdBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolEditGlossaryTerm: function (courseCode, glossaryId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling toolEditGlossaryTerm.');
                    }
                    // verify required parameter 'glossaryId' is not null or undefined
                    if (glossaryId === null || glossaryId === undefined) {
                        throw new base_1.RequiredError('glossaryId', 'Required parameter glossaryId was null or undefined when calling toolEditGlossaryTerm.');
                    }
                    localVarPath = "/course/{course_code}/tool/glossary/{glossary_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "glossary_id" + "}", encodeURIComponent(String(glossaryId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'PATCH' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get list of terms from course glossary
         * @param {string} courseCode unique string identifier of the course.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolGetGlossaryTerms: function (courseCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling toolGetGlossaryTerms.');
                    }
                    localVarPath = "/course/{course_code}/tool/glossary"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
    };
};
/**
 * CoursesApi - functional programming interface
 * @export
 */
exports.CoursesApiFp = function (configuration) {
    return {
        /**
         *
         * @summary Add a category
         * @param {CoursesCategoryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseAddCategory: function (body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseAddCategory(body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Add a course description
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {CourseCodeDescriptionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseAddDescription: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseAddDescription(courseCode, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Add a course
         * @param {CourseBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseCreate: function (body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseCreate(body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Delete course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDelete: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseDelete(courseCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Delete category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteCategory: function (categoryCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseDeleteCategory(categoryCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGet: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseGet(courseCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get backup of a course
         * @param {string} courseCode unique string identifier of the course to backup.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetBackup: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseGetBackup(courseCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get list of categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetCategories: function (options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseGetCategories(options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetCategory: function (categoryCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseGetCategory(categoryCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get list of courses
         * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
         * @param {number} [howmany] Number of results we want. Optional.
         * @param {number} [visibility] the visibility of the course, or all by default. Optional.
         * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
         * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetList: function (from, howmany, visibility, startwith, alsoSearchCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseGetList(from, howmany, visibility, startwith, alsoSearchCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get list of resources in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetResources: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).courseGetResources(courseCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Adds a new term to the course glossary tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {ToolGlossaryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolAddGlossaryTerm: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).toolAddGlossaryTerm(courseCode, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Adds an introduction text to specified tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {string} toolId The id of the tool.
         * @param {ToolIdIntroTextBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolAddIntroText: function (courseCode, toolId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).toolAddIntroText(courseCode, toolId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Deletes a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolDeleteGlossaryTerm: function (courseCode, glossaryId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).toolDeleteGlossaryTerm(courseCode, glossaryId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Edits a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {GlossaryGlossaryIdBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolEditGlossaryTerm: function (courseCode, glossaryId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).toolEditGlossaryTerm(courseCode, glossaryId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get list of terms from course glossary
         * @param {string} courseCode unique string identifier of the course.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolGetGlossaryTerms: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.CoursesApiAxiosParamCreator(configuration).toolGetGlossaryTerms(courseCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
    };
};
/**
 * CoursesApi - factory interface
 * @export
 */
exports.CoursesApiFactory = function (configuration, basePath, axios) {
    return {
        /**
         *
         * @summary Add a category
         * @param {CoursesCategoryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseAddCategory: function (body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseAddCategory(body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Add a course description
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {CourseCodeDescriptionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseAddDescription: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseAddDescription(courseCode, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Add a course
         * @param {CourseBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseCreate: function (body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseCreate(body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Delete course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDelete: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseDelete(courseCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Delete category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteCategory: function (categoryCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseDeleteCategory(categoryCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGet: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseGet(courseCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get backup of a course
         * @param {string} courseCode unique string identifier of the course to backup.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetBackup: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseGetBackup(courseCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get list of categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetCategories: function (options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseGetCategories(options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetCategory: function (categoryCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseGetCategory(categoryCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get list of courses
         * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
         * @param {number} [howmany] Number of results we want. Optional.
         * @param {number} [visibility] the visibility of the course, or all by default. Optional.
         * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
         * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetList: function (from, howmany, visibility, startwith, alsoSearchCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseGetList(from, howmany, visibility, startwith, alsoSearchCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get list of resources in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetResources: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).courseGetResources(courseCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Adds a new term to the course glossary tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {ToolGlossaryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolAddGlossaryTerm: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).toolAddGlossaryTerm(courseCode, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Adds an introduction text to specified tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {string} toolId The id of the tool.
         * @param {ToolIdIntroTextBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolAddIntroText: function (courseCode, toolId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).toolAddIntroText(courseCode, toolId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Deletes a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolDeleteGlossaryTerm: function (courseCode, glossaryId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).toolDeleteGlossaryTerm(courseCode, glossaryId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Edits a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {GlossaryGlossaryIdBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolEditGlossaryTerm: function (courseCode, glossaryId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).toolEditGlossaryTerm(courseCode, glossaryId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get list of terms from course glossary
         * @param {string} courseCode unique string identifier of the course.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolGetGlossaryTerms: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.CoursesApiFp(configuration).toolGetGlossaryTerms(courseCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
    };
};
/**
 * CoursesApi - object-oriented interface
 * @export
 * @class CoursesApi
 * @extends {BaseAPI}
 */
var CoursesApi = /** @class */ (function (_super) {
    __extends(CoursesApi, _super);
    function CoursesApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     *
     * @summary Add a category
     * @param {CoursesCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseAddCategory = function (body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseAddCategory(body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Add a course description
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {CourseCodeDescriptionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseAddDescription = function (courseCode, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseAddDescription(courseCode, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Add a course
     * @param {CourseBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseCreate = function (body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseCreate(body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Delete course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseDelete = function (courseCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseDelete(courseCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Delete category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseDeleteCategory = function (categoryCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseDeleteCategory(categoryCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseGet = function (courseCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseGet(courseCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get backup of a course
     * @param {string} courseCode unique string identifier of the course to backup.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseGetBackup = function (courseCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseGetBackup(courseCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get list of categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseGetCategories = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseGetCategories(options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseGetCategory = function (categoryCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseGetCategory(categoryCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get list of courses
     * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
     * @param {number} [howmany] Number of results we want. Optional.
     * @param {number} [visibility] the visibility of the course, or all by default. Optional.
     * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
     * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseGetList = function (from, howmany, visibility, startwith, alsoSearchCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseGetList(from, howmany, visibility, startwith, alsoSearchCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get list of resources in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.courseGetResources = function (courseCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).courseGetResources(courseCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Adds a new term to the course glossary tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {ToolGlossaryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.toolAddGlossaryTerm = function (courseCode, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).toolAddGlossaryTerm(courseCode, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Adds an introduction text to specified tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {string} toolId The id of the tool.
     * @param {ToolIdIntroTextBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.toolAddIntroText = function (courseCode, toolId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).toolAddIntroText(courseCode, toolId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Deletes a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.toolDeleteGlossaryTerm = function (courseCode, glossaryId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).toolDeleteGlossaryTerm(courseCode, glossaryId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Edits a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {GlossaryGlossaryIdBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.toolEditGlossaryTerm = function (courseCode, glossaryId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).toolEditGlossaryTerm(courseCode, glossaryId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get list of terms from course glossary
     * @param {string} courseCode unique string identifier of the course.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    CoursesApi.prototype.toolGetGlossaryTerms = function (courseCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.CoursesApiFp(this.configuration).toolGetGlossaryTerms(courseCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    return CoursesApi;
}(base_1.BaseAPI));
exports.CoursesApi = CoursesApi;
