"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LearningPathsApi = exports.LearningPathsApiFactory = exports.LearningPathsApiFp = exports.LearningPathsApiAxiosParamCreator = void 0;
/* tslint:disable */
/* eslint-disable */
/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
var axios_1 = require("axios");
// Some imports not used depending on template conditions
// @ts-ignore
var base_1 = require("../base");
/**
 * LearningPathsApi - axios parameter creator
 * @export
 */
exports.LearningPathsApiAxiosParamCreator = function (configuration) {
    var _this = this;
    return {
        /**
         *
         * @summary Create a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
         * @param {CourseCodeLearningpathBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreate: function (courseCode, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpCreate.');
                    }
                    localVarPath = "/course/{course_code}/learningpath"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Create a learning path category in a course
         * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
         * @param {LearningpathsCategoryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateCategory: function (courseCode, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpCreateCategory.');
                    }
                    localVarPath = "/course/{course_code}/learningpaths/category"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Creates an item in a learning path from a resource
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdItemBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateItem: function (courseCode, learningpathId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpCreateItem.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpCreateItem.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/item"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'PATCH' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Add section to learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdSectionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateSection: function (courseCode, learningpathId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpCreateSection.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpCreateSection.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/section"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Delete a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDelete: function (courseCode, learningpathId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpDelete.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpDelete.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Delete a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDeleteCategory: function (courseCode, categoryId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpDeleteCategory.');
                    }
                    // verify required parameter 'categoryId' is not null or undefined
                    if (categoryId === null || categoryId === undefined) {
                        throw new base_1.RequiredError('categoryId', 'Required parameter categoryId was null or undefined when calling lpDeleteCategory.');
                    }
                    localVarPath = "/course/{course_code}/learningpaths/category/{category_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "category_id" + "}", encodeURIComponent(String(categoryId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Delete section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDeleteSection: function (courseCode, learningpathId, sectionId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpDeleteSection.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpDeleteSection.');
                    }
                    // verify required parameter 'sectionId' is not null or undefined
                    if (sectionId === null || sectionId === undefined) {
                        throw new base_1.RequiredError('sectionId', 'Required parameter sectionId was null or undefined when calling lpDeleteSection.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/section/{section_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)))
                        .replace("{" + "section_id" + "}", encodeURIComponent(String(sectionId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get learningpath as scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {number} learningpathId unique int identifier of the learning path.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpExportScorm: function (courseCode, learningpathId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpExportScorm.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpExportScorm.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/scorm"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get a learning path from a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGet: function (courseCode, learningpathId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpGet.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpGet.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary List learning paths categories from course
         * @param {string} courseCode the id of the course from which to list the learning path categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetCategories: function (courseCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpGetCategories.');
                    }
                    localVarPath = "/course/{course_code}/learningpaths/categories"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetCategory: function (courseCode, categoryId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpGetCategory.');
                    }
                    // verify required parameter 'categoryId' is not null or undefined
                    if (categoryId === null || categoryId === undefined) {
                        throw new base_1.RequiredError('categoryId', 'Required parameter categoryId was null or undefined when calling lpGetCategory.');
                    }
                    localVarPath = "/course/{course_code}/learningpaths/category/{category_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "category_id" + "}", encodeURIComponent(String(categoryId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary List items (including sections) from course's learning path
         * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
         * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetItems: function (courseCode, learningpathId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpGetItems.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpGetItems.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/items"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get list of learning paths from course
         * @param {string} courseCode the id of the course from which to list the learning paths
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetList: function (courseCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpGetList.');
                    }
                    localVarPath = "/course/{course_code}/learningpaths"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetSection: function (courseCode, learningpathId, sectionId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpGetSection.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpGetSection.');
                    }
                    // verify required parameter 'sectionId' is not null or undefined
                    if (sectionId === null || sectionId === undefined) {
                        throw new base_1.RequiredError('sectionId', 'Required parameter sectionId was null or undefined when calling lpGetSection.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/section/{section_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)))
                        .replace("{" + "section_id" + "}", encodeURIComponent(String(sectionId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Create learningpath from scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {Blob} [scormUpload]
         * @param {number} [useMaxScore]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpImportScormForm: function (courseCode, scormUpload, useMaxScore, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarFormParams, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpImportScormForm.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/scorm"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    localVarFormParams = new FormData();
                    // authentication bearerAuth required
                    if (scormUpload !== undefined) {
                        localVarFormParams.append('scormUpload', scormUpload);
                    }
                    if (useMaxScore !== undefined) {
                        localVarFormParams.append('use_max_score', useMaxScore);
                    }
                    localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    localVarRequestOptions.data = localVarFormParams;
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Add existing audio document to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {LpItemIdAudioBody1} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpItemAddExistingAudio: function (courseCode, learningpathId, lpItemId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpItemAddExistingAudio.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpItemAddExistingAudio.');
                    }
                    // verify required parameter 'lpItemId' is not null or undefined
                    if (lpItemId === null || lpItemId === undefined) {
                        throw new base_1.RequiredError('lpItemId', 'Required parameter lpItemId was null or undefined when calling lpItemAddExistingAudio.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/item/{lp_item_id}/audio"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)))
                        .replace("{" + "lp_item_id" + "}", encodeURIComponent(String(lpItemId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'PATCH' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Add audio to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {Blob} [file]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpItemUploadAudioForm: function (courseCode, learningpathId, lpItemId, file, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarFormParams, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpItemUploadAudioForm.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpItemUploadAudioForm.');
                    }
                    // verify required parameter 'lpItemId' is not null or undefined
                    if (lpItemId === null || lpItemId === undefined) {
                        throw new base_1.RequiredError('lpItemId', 'Required parameter lpItemId was null or undefined when calling lpItemUploadAudioForm.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/item/{lp_item_id}/audio"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)))
                        .replace("{" + "lp_item_id" + "}", encodeURIComponent(String(lpItemId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    localVarFormParams = new FormData();
                    // authentication bearerAuth required
                    if (file !== undefined) {
                        localVarFormParams.append('file', file);
                    }
                    localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    localVarRequestOptions.data = localVarFormParams;
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
    };
};
/**
 * LearningPathsApi - functional programming interface
 * @export
 */
exports.LearningPathsApiFp = function (configuration) {
    return {
        /**
         *
         * @summary Create a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
         * @param {CourseCodeLearningpathBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreate: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpCreate(courseCode, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Create a learning path category in a course
         * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
         * @param {LearningpathsCategoryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateCategory: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpCreateCategory(courseCode, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Creates an item in a learning path from a resource
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdItemBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateItem: function (courseCode, learningpathId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpCreateItem(courseCode, learningpathId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Add section to learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdSectionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateSection: function (courseCode, learningpathId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpCreateSection(courseCode, learningpathId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Delete a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDelete: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpDelete(courseCode, learningpathId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Delete a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDeleteCategory: function (courseCode, categoryId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpDeleteCategory(courseCode, categoryId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Delete section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDeleteSection: function (courseCode, learningpathId, sectionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpDeleteSection(courseCode, learningpathId, sectionId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get learningpath as scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {number} learningpathId unique int identifier of the learning path.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpExportScorm: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpExportScorm(courseCode, learningpathId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get a learning path from a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGet: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpGet(courseCode, learningpathId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary List learning paths categories from course
         * @param {string} courseCode the id of the course from which to list the learning path categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetCategories: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpGetCategories(courseCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetCategory: function (courseCode, categoryId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpGetCategory(courseCode, categoryId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary List items (including sections) from course's learning path
         * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
         * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetItems: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpGetItems(courseCode, learningpathId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get list of learning paths from course
         * @param {string} courseCode the id of the course from which to list the learning paths
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetList: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpGetList(courseCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetSection: function (courseCode, learningpathId, sectionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpGetSection(courseCode, learningpathId, sectionId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Create learningpath from scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {Blob} [scormUpload]
         * @param {number} [useMaxScore]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpImportScormForm: function (courseCode, scormUpload, useMaxScore, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpImportScormForm(courseCode, scormUpload, useMaxScore, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Add existing audio document to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {LpItemIdAudioBody1} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpItemAddExistingAudio: function (courseCode, learningpathId, lpItemId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpItemAddExistingAudio(courseCode, learningpathId, lpItemId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Add audio to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {Blob} [file]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpItemUploadAudioForm: function (courseCode, learningpathId, lpItemId, file, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.LearningPathsApiAxiosParamCreator(configuration).lpItemUploadAudioForm(courseCode, learningpathId, lpItemId, file, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
    };
};
/**
 * LearningPathsApi - factory interface
 * @export
 */
exports.LearningPathsApiFactory = function (configuration, basePath, axios) {
    return {
        /**
         *
         * @summary Create a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
         * @param {CourseCodeLearningpathBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreate: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpCreate(courseCode, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Create a learning path category in a course
         * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
         * @param {LearningpathsCategoryBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateCategory: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpCreateCategory(courseCode, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Creates an item in a learning path from a resource
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdItemBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateItem: function (courseCode, learningpathId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpCreateItem(courseCode, learningpathId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Add section to learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdSectionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateSection: function (courseCode, learningpathId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpCreateSection(courseCode, learningpathId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Delete a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDelete: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpDelete(courseCode, learningpathId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Delete a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDeleteCategory: function (courseCode, categoryId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpDeleteCategory(courseCode, categoryId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Delete section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDeleteSection: function (courseCode, learningpathId, sectionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpDeleteSection(courseCode, learningpathId, sectionId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get learningpath as scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {number} learningpathId unique int identifier of the learning path.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpExportScorm: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpExportScorm(courseCode, learningpathId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get a learning path from a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGet: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpGet(courseCode, learningpathId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary List learning paths categories from course
         * @param {string} courseCode the id of the course from which to list the learning path categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetCategories: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpGetCategories(courseCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetCategory: function (courseCode, categoryId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpGetCategory(courseCode, categoryId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary List items (including sections) from course's learning path
         * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
         * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetItems: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpGetItems(courseCode, learningpathId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get list of learning paths from course
         * @param {string} courseCode the id of the course from which to list the learning paths
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetList: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpGetList(courseCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetSection: function (courseCode, learningpathId, sectionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpGetSection(courseCode, learningpathId, sectionId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Create learningpath from scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {Blob} [scormUpload]
         * @param {number} [useMaxScore]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpImportScormForm: function (courseCode, scormUpload, useMaxScore, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpImportScormForm(courseCode, scormUpload, useMaxScore, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Add existing audio document to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {LpItemIdAudioBody1} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpItemAddExistingAudio: function (courseCode, learningpathId, lpItemId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpItemAddExistingAudio(courseCode, learningpathId, lpItemId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Add audio to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {Blob} [file]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpItemUploadAudioForm: function (courseCode, learningpathId, lpItemId, file, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.LearningPathsApiFp(configuration).lpItemUploadAudioForm(courseCode, learningpathId, lpItemId, file, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
    };
};
/**
 * LearningPathsApi - object-oriented interface
 * @export
 * @class LearningPathsApi
 * @extends {BaseAPI}
 */
var LearningPathsApi = /** @class */ (function (_super) {
    __extends(LearningPathsApi, _super);
    function LearningPathsApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     *
     * @summary Create a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
     * @param {CourseCodeLearningpathBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpCreate = function (courseCode, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpCreate(courseCode, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Create a learning path category in a course
     * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
     * @param {LearningpathsCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpCreateCategory = function (courseCode, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpCreateCategory(courseCode, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Creates an item in a learning path from a resource
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdItemBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpCreateItem = function (courseCode, learningpathId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpCreateItem(courseCode, learningpathId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Add section to learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdSectionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpCreateSection = function (courseCode, learningpathId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpCreateSection(courseCode, learningpathId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Delete a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpDelete = function (courseCode, learningpathId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpDelete(courseCode, learningpathId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Delete a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpDeleteCategory = function (courseCode, categoryId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpDeleteCategory(courseCode, categoryId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Delete section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpDeleteSection = function (courseCode, learningpathId, sectionId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpDeleteSection(courseCode, learningpathId, sectionId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get learningpath as scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {number} learningpathId unique int identifier of the learning path.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpExportScorm = function (courseCode, learningpathId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpExportScorm(courseCode, learningpathId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get a learning path from a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpGet = function (courseCode, learningpathId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpGet(courseCode, learningpathId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary List learning paths categories from course
     * @param {string} courseCode the id of the course from which to list the learning path categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpGetCategories = function (courseCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpGetCategories(courseCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpGetCategory = function (courseCode, categoryId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpGetCategory(courseCode, categoryId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary List items (including sections) from course's learning path
     * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
     * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpGetItems = function (courseCode, learningpathId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpGetItems(courseCode, learningpathId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get list of learning paths from course
     * @param {string} courseCode the id of the course from which to list the learning paths
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpGetList = function (courseCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpGetList(courseCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpGetSection = function (courseCode, learningpathId, sectionId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpGetSection(courseCode, learningpathId, sectionId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Create learningpath from scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {Blob} [scormUpload]
     * @param {number} [useMaxScore]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpImportScormForm = function (courseCode, scormUpload, useMaxScore, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpImportScormForm(courseCode, scormUpload, useMaxScore, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Add existing audio document to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {LpItemIdAudioBody1} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpItemAddExistingAudio = function (courseCode, learningpathId, lpItemId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpItemAddExistingAudio(courseCode, learningpathId, lpItemId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Add audio to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {Blob} [file]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    LearningPathsApi.prototype.lpItemUploadAudioForm = function (courseCode, learningpathId, lpItemId, file, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.LearningPathsApiFp(this.configuration).lpItemUploadAudioForm(courseCode, learningpathId, lpItemId, file, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    return LearningPathsApi;
}(base_1.BaseAPI));
exports.LearningPathsApi = LearningPathsApi;
