"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestsApi = exports.TestsApiFactory = exports.TestsApiFp = exports.TestsApiAxiosParamCreator = void 0;
/* tslint:disable */
/* eslint-disable */
/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
var axios_1 = require("axios");
// Some imports not used depending on template conditions
// @ts-ignore
var base_1 = require("../base");
/**
 * TestsApi - axios parameter creator
 * @export
 */
exports.TestsApiAxiosParamCreator = function (configuration) {
    var _this = this;
    return {
        /**
         *
         * @summary Creates a question in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeQuestionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseCreateQuestion: function (courseCode, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseCreateQuestion.');
                    }
                    localVarPath = "/course/{course_code}/question"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Delete a question and remove it from all tests.
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteQuestion: function (courseCode, questionId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseDeleteQuestion.');
                    }
                    // verify required parameter 'questionId' is not null or undefined
                    if (questionId === null || questionId === undefined) {
                        throw new base_1.RequiredError('questionId', 'Required parameter questionId was null or undefined when calling courseDeleteQuestion.');
                    }
                    localVarPath = "/course/{course_code}/question/{question_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "question_id" + "}", encodeURIComponent(String(questionId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get a question from a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetQuestion: function (courseCode, questionId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseGetQuestion.');
                    }
                    // verify required parameter 'questionId' is not null or undefined
                    if (questionId === null || questionId === undefined) {
                        throw new base_1.RequiredError('questionId', 'Required parameter questionId was null or undefined when calling courseGetQuestion.');
                    }
                    localVarPath = "/course/{course_code}/question/{question_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "question_id" + "}", encodeURIComponent(String(questionId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
         * @param {string} courseCode unique string identifier of the course in which the answer will be located.
         * @param {string} testId unique int identifier of the test the answer will belong to.
         * @param {string} questionId unique int identifier of the question in which the answer will be added.
         * @param {QuestionIdAnswerBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionCreateAnswer: function (courseCode, testId, questionId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling questionCreateAnswer.');
                    }
                    // verify required parameter 'testId' is not null or undefined
                    if (testId === null || testId === undefined) {
                        throw new base_1.RequiredError('testId', 'Required parameter testId was null or undefined when calling questionCreateAnswer.');
                    }
                    // verify required parameter 'questionId' is not null or undefined
                    if (questionId === null || questionId === undefined) {
                        throw new base_1.RequiredError('questionId', 'Required parameter questionId was null or undefined when calling questionCreateAnswer.');
                    }
                    localVarPath = "/course/{course_code}/test/{test_id}/question/{question_id}/answer"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "test_id" + "}", encodeURIComponent(String(testId)))
                        .replace("{" + "question_id" + "}", encodeURIComponent(String(questionId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get answers from a question
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {string} testId unique integer identifier of the test.
         * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionGetAnswer: function (courseCode, testId, questionId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling questionGetAnswer.');
                    }
                    // verify required parameter 'testId' is not null or undefined
                    if (testId === null || testId === undefined) {
                        throw new base_1.RequiredError('testId', 'Required parameter testId was null or undefined when calling questionGetAnswer.');
                    }
                    // verify required parameter 'questionId' is not null or undefined
                    if (questionId === null || questionId === undefined) {
                        throw new base_1.RequiredError('questionId', 'Required parameter questionId was null or undefined when calling questionGetAnswer.');
                    }
                    localVarPath = "/course/{course_code}/test/{test_id}/question/{question_id}/answers"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "test_id" + "}", encodeURIComponent(String(testId)))
                        .replace("{" + "question_id" + "}", encodeURIComponent(String(questionId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Upload an image into a question
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} questionId unique string identifier of the parent question.
         * @param {Blob} [imageUpload]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionUploadImageForm: function (courseCode, questionId, imageUpload, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarFormParams, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling questionUploadImageForm.');
                    }
                    // verify required parameter 'questionId' is not null or undefined
                    if (questionId === null || questionId === undefined) {
                        throw new base_1.RequiredError('questionId', 'Required parameter questionId was null or undefined when calling questionUploadImageForm.');
                    }
                    localVarPath = "/course/{course_code}/question/{question_id}/image"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "question_id" + "}", encodeURIComponent(String(questionId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    localVarFormParams = new FormData();
                    // authentication bearerAuth required
                    if (imageUpload !== undefined) {
                        localVarFormParams.append('imageUpload', imageUpload);
                    }
                    localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    localVarRequestOptions.data = localVarFormParams;
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Create a test in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeTestBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreate: function (courseCode, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling testCreate.');
                    }
                    localVarPath = "/course/{course_code}/test"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Create a test in a learningpath
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
         * @param {LearningpathIdTestBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreateInLp: function (courseCode, learningpathId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling testCreateInLp.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling testCreateInLp.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/test"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Create a question in a test
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} testId unique int identifier of the test in which the question will be added.
         * @param {TestIdQuestionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreateQuestion: function (courseCode, testId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling testCreateQuestion.');
                    }
                    // verify required parameter 'testId' is not null or undefined
                    if (testId === null || testId === undefined) {
                        throw new base_1.RequiredError('testId', 'Required parameter testId was null or undefined when calling testCreateQuestion.');
                    }
                    localVarPath = "/course/{course_code}/test/{test_id}/question"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "test_id" + "}", encodeURIComponent(String(testId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Delete a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testDelete: function (courseCode, testId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling testDelete.');
                    }
                    // verify required parameter 'testId' is not null or undefined
                    if (testId === null || testId === undefined) {
                        throw new base_1.RequiredError('testId', 'Required parameter testId was null or undefined when calling testDelete.');
                    }
                    localVarPath = "/course/{course_code}/test/{test_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "test_id" + "}", encodeURIComponent(String(testId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGet: function (courseCode, testId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling testGet.');
                    }
                    // verify required parameter 'testId' is not null or undefined
                    if (testId === null || testId === undefined) {
                        throw new base_1.RequiredError('testId', 'Required parameter testId was null or undefined when calling testGet.');
                    }
                    localVarPath = "/course/{course_code}/test/{test_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "test_id" + "}", encodeURIComponent(String(testId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get list of tests in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGetList: function (courseCode, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling testGetList.');
                    }
                    localVarPath = "/course/{course_code}/tests"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get questions from a test
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {number} testId unique integer identifier of the test you wish to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGetQuestions: function (courseCode, testId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling testGetQuestions.');
                    }
                    // verify required parameter 'testId' is not null or undefined
                    if (testId === null || testId === undefined) {
                        throw new base_1.RequiredError('testId', 'Required parameter testId was null or undefined when calling testGetQuestions.');
                    }
                    localVarPath = "/course/{course_code}/test/{test_id}/questions"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "test_id" + "}", encodeURIComponent(String(testId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Remove a question from a test.
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} testId unique integer identifier of the parent test.
         * @param {string} questionId unique integer identifier of the parent question.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testRemoveQuestion: function (courseCode, testId, questionId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling testRemoveQuestion.');
                    }
                    // verify required parameter 'testId' is not null or undefined
                    if (testId === null || testId === undefined) {
                        throw new base_1.RequiredError('testId', 'Required parameter testId was null or undefined when calling testRemoveQuestion.');
                    }
                    // verify required parameter 'questionId' is not null or undefined
                    if (questionId === null || questionId === undefined) {
                        throw new base_1.RequiredError('questionId', 'Required parameter questionId was null or undefined when calling testRemoveQuestion.');
                    }
                    localVarPath = "/course/{course_code}/test/{test_id}/question/{question_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "test_id" + "}", encodeURIComponent(String(testId)))
                        .replace("{" + "question_id" + "}", encodeURIComponent(String(questionId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'PATCH' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
    };
};
/**
 * TestsApi - functional programming interface
 * @export
 */
exports.TestsApiFp = function (configuration) {
    return {
        /**
         *
         * @summary Creates a question in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeQuestionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseCreateQuestion: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).courseCreateQuestion(courseCode, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Delete a question and remove it from all tests.
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteQuestion: function (courseCode, questionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).courseDeleteQuestion(courseCode, questionId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get a question from a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetQuestion: function (courseCode, questionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).courseGetQuestion(courseCode, questionId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
         * @param {string} courseCode unique string identifier of the course in which the answer will be located.
         * @param {string} testId unique int identifier of the test the answer will belong to.
         * @param {string} questionId unique int identifier of the question in which the answer will be added.
         * @param {QuestionIdAnswerBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionCreateAnswer: function (courseCode, testId, questionId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).questionCreateAnswer(courseCode, testId, questionId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get answers from a question
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {string} testId unique integer identifier of the test.
         * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionGetAnswer: function (courseCode, testId, questionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).questionGetAnswer(courseCode, testId, questionId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Upload an image into a question
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} questionId unique string identifier of the parent question.
         * @param {Blob} [imageUpload]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionUploadImageForm: function (courseCode, questionId, imageUpload, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).questionUploadImageForm(courseCode, questionId, imageUpload, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Create a test in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeTestBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreate: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).testCreate(courseCode, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Create a test in a learningpath
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
         * @param {LearningpathIdTestBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreateInLp: function (courseCode, learningpathId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).testCreateInLp(courseCode, learningpathId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Create a question in a test
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} testId unique int identifier of the test in which the question will be added.
         * @param {TestIdQuestionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreateQuestion: function (courseCode, testId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).testCreateQuestion(courseCode, testId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Delete a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testDelete: function (courseCode, testId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).testDelete(courseCode, testId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGet: function (courseCode, testId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).testGet(courseCode, testId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get list of tests in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGetList: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).testGetList(courseCode, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get questions from a test
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {number} testId unique integer identifier of the test you wish to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGetQuestions: function (courseCode, testId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).testGetQuestions(courseCode, testId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Remove a question from a test.
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} testId unique integer identifier of the parent test.
         * @param {string} questionId unique integer identifier of the parent question.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testRemoveQuestion: function (courseCode, testId, questionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.TestsApiAxiosParamCreator(configuration).testRemoveQuestion(courseCode, testId, questionId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
    };
};
/**
 * TestsApi - factory interface
 * @export
 */
exports.TestsApiFactory = function (configuration, basePath, axios) {
    return {
        /**
         *
         * @summary Creates a question in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeQuestionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseCreateQuestion: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).courseCreateQuestion(courseCode, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Delete a question and remove it from all tests.
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteQuestion: function (courseCode, questionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).courseDeleteQuestion(courseCode, questionId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get a question from a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetQuestion: function (courseCode, questionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).courseGetQuestion(courseCode, questionId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
         * @param {string} courseCode unique string identifier of the course in which the answer will be located.
         * @param {string} testId unique int identifier of the test the answer will belong to.
         * @param {string} questionId unique int identifier of the question in which the answer will be added.
         * @param {QuestionIdAnswerBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionCreateAnswer: function (courseCode, testId, questionId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).questionCreateAnswer(courseCode, testId, questionId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get answers from a question
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {string} testId unique integer identifier of the test.
         * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionGetAnswer: function (courseCode, testId, questionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).questionGetAnswer(courseCode, testId, questionId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Upload an image into a question
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} questionId unique string identifier of the parent question.
         * @param {Blob} [imageUpload]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionUploadImageForm: function (courseCode, questionId, imageUpload, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).questionUploadImageForm(courseCode, questionId, imageUpload, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Create a test in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeTestBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreate: function (courseCode, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).testCreate(courseCode, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Create a test in a learningpath
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
         * @param {LearningpathIdTestBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreateInLp: function (courseCode, learningpathId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).testCreateInLp(courseCode, learningpathId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Create a question in a test
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} testId unique int identifier of the test in which the question will be added.
         * @param {TestIdQuestionBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreateQuestion: function (courseCode, testId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).testCreateQuestion(courseCode, testId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Delete a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testDelete: function (courseCode, testId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).testDelete(courseCode, testId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGet: function (courseCode, testId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).testGet(courseCode, testId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get list of tests in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGetList: function (courseCode, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).testGetList(courseCode, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get questions from a test
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {number} testId unique integer identifier of the test you wish to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGetQuestions: function (courseCode, testId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).testGetQuestions(courseCode, testId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Remove a question from a test.
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} testId unique integer identifier of the parent test.
         * @param {string} questionId unique integer identifier of the parent question.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testRemoveQuestion: function (courseCode, testId, questionId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.TestsApiFp(configuration).testRemoveQuestion(courseCode, testId, questionId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
    };
};
/**
 * TestsApi - object-oriented interface
 * @export
 * @class TestsApi
 * @extends {BaseAPI}
 */
var TestsApi = /** @class */ (function (_super) {
    __extends(TestsApi, _super);
    function TestsApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     *
     * @summary Creates a question in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.courseCreateQuestion = function (courseCode, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).courseCreateQuestion(courseCode, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Delete a question and remove it from all tests.
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.courseDeleteQuestion = function (courseCode, questionId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).courseDeleteQuestion(courseCode, questionId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get a question from a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.courseGetQuestion = function (courseCode, questionId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).courseGetQuestion(courseCode, questionId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
     * @param {string} courseCode unique string identifier of the course in which the answer will be located.
     * @param {string} testId unique int identifier of the test the answer will belong to.
     * @param {string} questionId unique int identifier of the question in which the answer will be added.
     * @param {QuestionIdAnswerBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.questionCreateAnswer = function (courseCode, testId, questionId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).questionCreateAnswer(courseCode, testId, questionId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get answers from a question
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {string} testId unique integer identifier of the test.
     * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.questionGetAnswer = function (courseCode, testId, questionId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).questionGetAnswer(courseCode, testId, questionId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Upload an image into a question
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} questionId unique string identifier of the parent question.
     * @param {Blob} [imageUpload]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.questionUploadImageForm = function (courseCode, questionId, imageUpload, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).questionUploadImageForm(courseCode, questionId, imageUpload, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Create a test in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.testCreate = function (courseCode, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).testCreate(courseCode, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Create a test in a learningpath
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
     * @param {LearningpathIdTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.testCreateInLp = function (courseCode, learningpathId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).testCreateInLp(courseCode, learningpathId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Create a question in a test
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} testId unique int identifier of the test in which the question will be added.
     * @param {TestIdQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.testCreateQuestion = function (courseCode, testId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).testCreateQuestion(courseCode, testId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Delete a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.testDelete = function (courseCode, testId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).testDelete(courseCode, testId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.testGet = function (courseCode, testId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).testGet(courseCode, testId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get list of tests in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.testGetList = function (courseCode, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).testGetList(courseCode, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get questions from a test
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {number} testId unique integer identifier of the test you wish to retrieve.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.testGetQuestions = function (courseCode, testId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).testGetQuestions(courseCode, testId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Remove a question from a test.
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} testId unique integer identifier of the parent test.
     * @param {string} questionId unique integer identifier of the parent question.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    TestsApi.prototype.testRemoveQuestion = function (courseCode, testId, questionId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.TestsApiFp(this.configuration).testRemoveQuestion(courseCode, testId, questionId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    return TestsApi;
}(base_1.BaseAPI));
exports.TestsApi = TestsApi;
