"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocumentsApi = exports.DocumentsApiFactory = exports.DocumentsApiFp = exports.DocumentsApiAxiosParamCreator = void 0;
/* tslint:disable */
/* eslint-disable */
/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
var axios_1 = require("axios");
// Some imports not used depending on template conditions
// @ts-ignore
var base_1 = require("../base");
/**
 * DocumentsApi - axios parameter creator
 * @export
 */
exports.DocumentsApiAxiosParamCreator = function (configuration) {
    var _this = this;
    return {
        /**
         *
         * @summary Soft delete a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteDocument: function (courseCode, documentId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseDeleteDocument.');
                    }
                    // verify required parameter 'documentId' is not null or undefined
                    if (documentId === null || documentId === undefined) {
                        throw new base_1.RequiredError('documentId', 'Required parameter documentId was null or undefined when calling courseDeleteDocument.');
                    }
                    localVarPath = "/course/{course_code}/document/{document_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "document_id" + "}", encodeURIComponent(String(documentId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetDocument: function (courseCode, documentId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseGetDocument.');
                    }
                    // verify required parameter 'documentId' is not null or undefined
                    if (documentId === null || documentId === undefined) {
                        throw new base_1.RequiredError('documentId', 'Required parameter documentId was null or undefined when calling courseGetDocument.');
                    }
                    localVarPath = "/course/{course_code}/document/{document_id}"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "document_id" + "}", encodeURIComponent(String(documentId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get list of documents in course
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetDocuments: function (courseCode, path, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseGetDocuments.');
                    }
                    localVarPath = "/course/{course_code}/documents"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    if (path !== undefined) {
                        localVarQueryParameter['path'] = path;
                    }
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Upload a document into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [file]
         * @param {string} [path]
         * @param {string} [title]
         * @param {string} [comment]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseUploadDocumentForm: function (courseCode, file, path, title, comment, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarFormParams, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseUploadDocumentForm.');
                    }
                    localVarPath = "/course/{course_code}/document"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    localVarFormParams = new FormData();
                    // authentication bearerAuth required
                    if (file !== undefined) {
                        localVarFormParams.append('file', file);
                    }
                    if (path !== undefined) {
                        localVarFormParams.append('path', path);
                    }
                    if (title !== undefined) {
                        localVarFormParams.append('title', title);
                    }
                    if (comment !== undefined) {
                        localVarFormParams.append('comment', comment);
                    }
                    localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    localVarRequestOptions.data = localVarFormParams;
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Upload an image into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [imageUpload]
         * @param {string} [title]
         * @param {string} [comment]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseUploadImageForm: function (courseCode, imageUpload, title, comment, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, localVarFormParams, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling courseUploadImageForm.');
                    }
                    localVarPath = "/course/{course_code}/documents/image"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    localVarFormParams = new FormData();
                    // authentication bearerAuth required
                    if (imageUpload !== undefined) {
                        localVarFormParams.append('imageUpload', imageUpload);
                    }
                    if (title !== undefined) {
                        localVarFormParams.append('title', title);
                    }
                    if (comment !== undefined) {
                        localVarFormParams.append('comment', comment);
                    }
                    localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    localVarRequestOptions.data = localVarFormParams;
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Create a document in a learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdDocumentBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateDocument: function (courseCode, learningpathId, body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpCreateDocument.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpCreateDocument.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/document"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    // authentication bearerAuth required
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         *
         * @summary Get list of documents in learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetDocuments: function (courseCode, learningpathId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'courseCode' is not null or undefined
                    if (courseCode === null || courseCode === undefined) {
                        throw new base_1.RequiredError('courseCode', 'Required parameter courseCode was null or undefined when calling lpGetDocuments.');
                    }
                    // verify required parameter 'learningpathId' is not null or undefined
                    if (learningpathId === null || learningpathId === undefined) {
                        throw new base_1.RequiredError('learningpathId', 'Required parameter learningpathId was null or undefined when calling lpGetDocuments.');
                    }
                    localVarPath = "/course/{course_code}/learningpath/{learningpath_id}/documents"
                        .replace("{" + "course_code" + "}", encodeURIComponent(String(courseCode)))
                        .replace("{" + "learningpath_id" + "}", encodeURIComponent(String(learningpathId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.params) {
                        query.set(key, options.params[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
    };
};
/**
 * DocumentsApi - functional programming interface
 * @export
 */
exports.DocumentsApiFp = function (configuration) {
    return {
        /**
         *
         * @summary Soft delete a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteDocument: function (courseCode, documentId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.DocumentsApiAxiosParamCreator(configuration).courseDeleteDocument(courseCode, documentId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetDocument: function (courseCode, documentId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.DocumentsApiAxiosParamCreator(configuration).courseGetDocument(courseCode, documentId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get list of documents in course
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetDocuments: function (courseCode, path, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.DocumentsApiAxiosParamCreator(configuration).courseGetDocuments(courseCode, path, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Upload a document into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [file]
         * @param {string} [path]
         * @param {string} [title]
         * @param {string} [comment]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseUploadDocumentForm: function (courseCode, file, path, title, comment, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.DocumentsApiAxiosParamCreator(configuration).courseUploadDocumentForm(courseCode, file, path, title, comment, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Upload an image into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [imageUpload]
         * @param {string} [title]
         * @param {string} [comment]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseUploadImageForm: function (courseCode, imageUpload, title, comment, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.DocumentsApiAxiosParamCreator(configuration).courseUploadImageForm(courseCode, imageUpload, title, comment, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Create a document in a learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdDocumentBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateDocument: function (courseCode, learningpathId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.DocumentsApiAxiosParamCreator(configuration).lpCreateDocument(courseCode, learningpathId, body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         *
         * @summary Get list of documents in learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetDocuments: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.DocumentsApiAxiosParamCreator(configuration).lpGetDocuments(courseCode, learningpathId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
    };
};
/**
 * DocumentsApi - factory interface
 * @export
 */
exports.DocumentsApiFactory = function (configuration, basePath, axios) {
    return {
        /**
         *
         * @summary Soft delete a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteDocument: function (courseCode, documentId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.DocumentsApiFp(configuration).courseDeleteDocument(courseCode, documentId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetDocument: function (courseCode, documentId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.DocumentsApiFp(configuration).courseGetDocument(courseCode, documentId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get list of documents in course
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetDocuments: function (courseCode, path, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.DocumentsApiFp(configuration).courseGetDocuments(courseCode, path, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Upload a document into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [file]
         * @param {string} [path]
         * @param {string} [title]
         * @param {string} [comment]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseUploadDocumentForm: function (courseCode, file, path, title, comment, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.DocumentsApiFp(configuration).courseUploadDocumentForm(courseCode, file, path, title, comment, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Upload an image into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [imageUpload]
         * @param {string} [title]
         * @param {string} [comment]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseUploadImageForm: function (courseCode, imageUpload, title, comment, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.DocumentsApiFp(configuration).courseUploadImageForm(courseCode, imageUpload, title, comment, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Create a document in a learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdDocumentBody} [body]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateDocument: function (courseCode, learningpathId, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.DocumentsApiFp(configuration).lpCreateDocument(courseCode, learningpathId, body, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
        /**
         *
         * @summary Get list of documents in learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetDocuments: function (courseCode, learningpathId, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, exports.DocumentsApiFp(configuration).lpGetDocuments(courseCode, learningpathId, options).then(function (request) { return request(axios, basePath); })];
                });
            });
        },
    };
};
/**
 * DocumentsApi - object-oriented interface
 * @export
 * @class DocumentsApi
 * @extends {BaseAPI}
 */
var DocumentsApi = /** @class */ (function (_super) {
    __extends(DocumentsApi, _super);
    function DocumentsApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     *
     * @summary Soft delete a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    DocumentsApi.prototype.courseDeleteDocument = function (courseCode, documentId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.DocumentsApiFp(this.configuration).courseDeleteDocument(courseCode, documentId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    DocumentsApi.prototype.courseGetDocument = function (courseCode, documentId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.DocumentsApiFp(this.configuration).courseGetDocument(courseCode, documentId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get list of documents in course
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    DocumentsApi.prototype.courseGetDocuments = function (courseCode, path, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.DocumentsApiFp(this.configuration).courseGetDocuments(courseCode, path, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Upload a document into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [file]
     * @param {string} [path]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    DocumentsApi.prototype.courseUploadDocumentForm = function (courseCode, file, path, title, comment, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.DocumentsApiFp(this.configuration).courseUploadDocumentForm(courseCode, file, path, title, comment, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Upload an image into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [imageUpload]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    DocumentsApi.prototype.courseUploadImageForm = function (courseCode, imageUpload, title, comment, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.DocumentsApiFp(this.configuration).courseUploadImageForm(courseCode, imageUpload, title, comment, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Create a document in a learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdDocumentBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    DocumentsApi.prototype.lpCreateDocument = function (courseCode, learningpathId, body, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.DocumentsApiFp(this.configuration).lpCreateDocument(courseCode, learningpathId, body, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    /**
     *
     * @summary Get list of documents in learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    DocumentsApi.prototype.lpGetDocuments = function (courseCode, learningpathId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, exports.DocumentsApiFp(this.configuration).lpGetDocuments(courseCode, learningpathId, options).then(function (request) { return request(_this.axios, _this.basePath); })];
            });
        });
    };
    return DocumentsApi;
}(base_1.BaseAPI));
exports.DocumentsApi = DocumentsApi;
